<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="html"/>

    <xsl:template match="/list">
        <html>
            <head>
                <meta http-equiv="Content-Type" content="text/ html; charset=UTF-8"/>
            </head>
            <body>
                <h1>
                    <xsl:value-of select="@operation"/>
                </h1>
                <ul>
                    <xsl:for-each select="item">
                        <li>
                            <xsl:choose>
                                <xsl:when test="contains(/list/@operation, '{')">
                                    <xsl:value-of select="text()"/>
                                </xsl:when>
                                <xsl:otherwise>
                                    <!-- relative path -->
                                    <a href="{/list/@operation}/{text()}">
                                        <xsl:value-of select="text()"/>
                                    </a>
                                </xsl:otherwise>
                            </xsl:choose>
                        </li>
                    </xsl:for-each>
                </ul>
            </body>
        </html>
    </xsl:template>
</xsl:stylesheet>