<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:symod="http://www.in2p3.fr/symod"
                xmlns="http://www.w3.org/1999/xhtml">
    <xsl:template match="/symod:query">
        <html>
            <head>
                <style type="text/css">
table,tr,td,th {
    font-family:tahoma, arial, verdana, sans-serif;
    border-collapse: collapse;
    border-spacing: 0;
    border : solid 0px #BBD;
    margin:0;padding:4px;
    font-size:12px;
}
table { border-bottom : solid 1px #BBD;}
td,th { text-align:center; border-top : solid 1px #BBD;border-left : solid 1px #BBD;border-right : solid 1px #BBD;}
th {
    text-align:left
    min-width:80px;
    line-height:15px;
    background-color:lightgrey;
    background-image:-webkit-gradient(linear, 50% 0%, 50% 100%, color-stop(0%, #f9f9f9), color-stop(100%, #e3e4e6));
    background-image:-webkit-linear-gradient(top, #f9f9f9,#e3e4e6);
    background-image:-moz-linear-gradient(top, #f9f9f9,#e3e4e6);
    background-image:-o-linear-gradient(top, #f9f9f9,#e3e4e6);
    background-image:-ms-linear-gradient(top, #f9f9f9,#e3e4e6);
    background-image:linear-gradient(top, #f9f9f9,#e3e4e6);
    font-size:11px;
}
caption {
    font-weight: bold;
}
                </style>
            </head>
            <body>
                <p><xsl:value-of select="symod:description"/></p>
                <xsl:apply-templates select="symod:time"/>
                <xsl:apply-templates select="symod:entity"/>
                <br/><b><a href="#">+</a></b>
                <xsl:call-template name="GLOBAL_VALUES"/>
                <hr/>
                Jointures: <img src="#" alt="TODO"/>
                <hr/>
                <form action="qbe" method="post">
                    <textarea name="query" rows="10" cols="100">
                        <xsl:copy-of select="."/>
                    </textarea>
                    <input type="submit" name="action" value="refresh"/>
                </form>
            </body>
        </html>
    </xsl:template>

    <xsl:template match="symod:time">
        <br/>
        <table cellspacing="0" cellpadding="0">
            <caption>TIME</caption>
            <thead>
                <xsl:if test="@name or symod:print/@as">
                    <tr>
                        <th>alias</th>
                        <th><xsl:call-template name="LABEL"/></th>
                    </tr>
                </xsl:if>
            </thead>
            <tbody>
                <!-- for each attribute -->
                <xsl:for-each select="@*[local-name()!='name' and local-name()!='descending']">
                    <xsl:sort select="local-name()"/>
                    <tr>
                        <th><xsl:value-of select="local-name()"/></th>
                        <td><xsl:apply-templates select="."/></td>
                    </tr>
                </xsl:for-each>
                <!-- for each child element -->
                <xsl:for-each select="symod:*">
                    <xsl:sort select="local-name()"/>
                    <xsl:variable name="element" select="local-name()"/>
                    <tr>
                        <th><xsl:value-of select="$element"/></th>
                        <td><xsl:apply-templates select="."/></td>
                    </tr>
                </xsl:for-each>
                <tr>
                    <th><xsl:comment> empty cell </xsl:comment></th>
                    <td align="center"><a href="#">edit</a>, <a href="#">delete</a></td>
                </tr>
            </tbody>
        </table>
    </xsl:template>

    <xsl:template match="symod:entity">
        <xsl:variable name="nonEmptyValues" select="symod:value[symod:* or @*[local-name()!='TYPE']]"/>
        <br/>
        <table cellspacing="0" cellpadding="0">
            <caption><xsl:value-of select="@TYPE"/>[<xsl:value-of select="position()"/>]</caption>
            <thead>
                <tr>
                    <th><xsl:comment> empty cell </xsl:comment></th>
                    <xsl:for-each select="$nonEmptyValues">
                        <th><xsl:value-of select="@TYPE"/></th>
                    </xsl:for-each>
                    <th><a href="#">+</a></th>
                </tr>
                <xsl:if test="$nonEmptyValues[@name or symod:print/@as]">
                    <tr>
                        <th>alias</th>
                        <xsl:for-each select="$nonEmptyValues">
                            <th><xsl:call-template name="LABEL"/></th>
                        </xsl:for-each>
                    </tr>
                </xsl:if>
            </thead>
            <tbody>
                <!-- for each attribute -->
                <xsl:for-each select="symod:value/@*[local-name()!='TYPE' and local-name()!='link' and local-name()!='name' and local-name()!='descending']">
                    <xsl:sort select="local-name()"/>
                    <xsl:if test="not(parent::symod:value/preceding-sibling::symod:value/@*[local-name()=local-name(current())])">
                        <xsl:variable name="attribute" select="local-name()"/>
                        <tr>
                            <th><xsl:value-of select="$attribute"/></th>
                            <xsl:for-each select="$nonEmptyValues">
                                <td><xsl:apply-templates select="@*[local-name()=$attribute]"/></td>
                            </xsl:for-each>
                        </tr>
                    </xsl:if>
                </xsl:for-each>
                <!-- for each child element -->
                <xsl:for-each select="symod:value/symod:*">
                    <xsl:sort select="local-name()"/>
                    <xsl:if test="not(parent::symod:value/preceding-sibling::symod:value/symod:*[local-name()=local-name(current())])">
                        <xsl:variable name="element" select="local-name()"/>
                        <tr>
                            <th><xsl:value-of select="$element"/></th>
                            <xsl:for-each select="$nonEmptyValues">
                                <td><xsl:apply-templates select="symod:*[local-name()=$element]"/></td>
                            </xsl:for-each>
                        </tr>
                    </xsl:if>
                </xsl:for-each>
                <tr>
                    <th><xsl:comment> empty cell </xsl:comment></th>
                    <xsl:for-each select="$nonEmptyValues">
                        <td align="center"><a href="#">edit</a>, <a href="#">delete</a></td>
                    </xsl:for-each>
                </tr>
            </tbody>
        </table>
    </xsl:template>

    <xsl:template name="GLOBAL_VALUES">
        <xsl:variable name="nonEmptyValues" select="symod:global_value[symod:* or @*]"/>
        <br/>
        <table cellspacing="0" cellpadding="0">
            <caption>GLOBAL VALUES</caption>
            <thead>
                <tr>
                    <th>alias</th>
                    <xsl:for-each select="$nonEmptyValues">
                        <th><xsl:call-template name="LABEL"/></th>
                    </xsl:for-each>
                    <th><a href="#">+</a></th>
                </tr>
            </thead>
            <tbody>
                <!-- for each attribute -->
                <xsl:for-each select="symod:global_value/@*[local-name()!='name' and local-name()!='descending']">
                    <xsl:sort select="local-name()"/>
                    <xsl:if test="not(parent::symod:global_value/preceding-sibling::symod:global_value/@*[local-name()=local-name(current())])">
                        <xsl:variable name="attribute" select="local-name()"/>
                        <tr>
                            <th><xsl:value-of select="$attribute"/></th>
                            <xsl:for-each select="$nonEmptyValues">
                                <td><xsl:apply-templates select="@*[local-name()=$attribute]"/></td>
                            </xsl:for-each>
                        </tr>
                    </xsl:if>
                </xsl:for-each>
                <!-- for each child element -->
                <xsl:for-each select="symod:global_value/symod:*">
                    <xsl:sort select="local-name()"/>
                    <xsl:if test="not(parent::symod:global_value/preceding-sibling::symod:global_value/symod:*[local-name()=local-name(current())])">
                        <xsl:variable name="element" select="local-name()"/>
                        <tr>
                            <th><xsl:value-of select="$element"/></th>
                            <xsl:for-each select="$nonEmptyValues">
                                <td><xsl:apply-templates select="symod:*[local-name()=$element]"/></td>
                            </xsl:for-each>
                        </tr>
                    </xsl:if>
                </xsl:for-each>
                <tr>
                    <th><xsl:comment> empty cell </xsl:comment></th>
                    <xsl:for-each select="$nonEmptyValues">
                        <td align="center"><a href="#">edit</a>, <a href="#">delete</a></td>
                    </xsl:for-each>
                </tr>
            </tbody>
        </table>
    </xsl:template>

    <xsl:template name="LABEL">
        <xsl:choose>
            <xsl:when test="@name and symod:print/@as"><xsl:value-of select="@name"/> (as "<xsl:value-of select="symod:print/@as"/>")</xsl:when>
            <xsl:when test="@name"><xsl:value-of select="@name"/></xsl:when>
            <xsl:when test="symod:print/@as"><xsl:value-of select="symod:print/@as"/></xsl:when>
        </xsl:choose>
    </xsl:template>

    <xsl:template match="@order">
        <b><xsl:value-of select="."/></b>
        <xsl:choose>
            <xsl:when test="parent::symod:*/@descending='true'"> [v]</xsl:when>
            <xsl:otherwise> [^]</xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="@*">
        <xsl:value-of select="."/>
    </xsl:template>

    <xsl:template match="symod:print">
        <b><xsl:choose>
            <xsl:when test="@position"><xsl:value-of select="@position"/></xsl:when>
            <xsl:otherwise>99</xsl:otherwise>
        </xsl:choose></b>
        <xsl:if test="@format"><br/><i>format="<xsl:value-of select="@format"/>"</i></xsl:if>
    </xsl:template>
    <xsl:template match="symod:since | symod:until | symod:period">
        <xsl:choose>
            <xsl:when test="@date"><xsl:value-of select="@date"/></xsl:when>
            <xsl:when test="@duration"><xsl:value-of select="@duration"/></xsl:when>
            <xsl:otherwise>ERROR</xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="symod:resolution">
        <xsl:attribute name="style">text-align: <xsl:choose>
            <xsl:when test="@plot='start'">left</xsl:when>
            <xsl:when test="@plot='middle'">center</xsl:when>
            <xsl:when test="@plot='end'">right</xsl:when>
        </xsl:choose>
        </xsl:attribute>
        <xsl:choose>
            <xsl:when test="@duration"><xsl:value-of select="@duration"/></xsl:when>
            <xsl:when test="@count"><xsl:value-of select="@count"/> plots</xsl:when>
            <xsl:otherwise>all plots</xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="symod:constraint">
        <xsl:value-of select="text()"/>
    </xsl:template>
</xsl:stylesheet>
