<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:wadl="http://wadl.dev.java.net/2009/02">
    <xsl:output method="text"/>
    <xsl:variable name="BASE">/symod</xsl:variable>

    <xsl:template match="/">
        <xsl:apply-templates select="wadl:application/wadl:resources/wadl:resource[@path=$BASE]/wadl:resource"/>
    </xsl:template>

    <xsl:template match="wadl:resource[contains(@path, '/{')]">
        <xsl:variable name="prefix" select="substring-before(@path, '/{')"/>
        <xsl:attribute name="href">
            <!--<xsl:value-of select="/wadl:application/wadl:resources/@base"/>-->
            <xsl:value-of select="$prefix"/>
            <xsl:if test="not(preceding-sibling::wadl:resource[@path=$prefix])">
                <xsl:text>/_</xsl:text>
            </xsl:if>
        </xsl:attribute>
        <xsl:value-of select="$prefix"/>/{<xsl:value-of select="substring-after(@path, '/{')"/>
        <xsl:text>
</xsl:text>
    </xsl:template>
    <xsl:template match="wadl:resource[starts-with(following-sibling::wadl:resource/@path, concat(@path,'/'))]">
        <!-- ignore -->
    </xsl:template>
    <xsl:template match="wadl:resource">
        <xsl:attribute name="href">
            <!--<xsl:value-of select="/wadl:application/wadl:resources/@base"/>-->
            <xsl:value-of select="@path"/>
        </xsl:attribute>
        <xsl:value-of select="@path"/>
        <xsl:apply-templates select="wadl:method/wadl:request/wadl:param"/>
        <xsl:text>
</xsl:text>
    </xsl:template>

    <xsl:template match="wadl:param">
        <xsl:choose>
            <xsl:when test="position()=1">?</xsl:when>
            <xsl:otherwise>&amp;</xsl:otherwise>
        </xsl:choose>
        <xsl:value-of select="@name"/>
        <xsl:text>=_</xsl:text>
    </xsl:template>
</xsl:stylesheet>
