<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:symod="http://www.in2p3.fr/symod" exclude-result-prefixes="symod"
                xmlns="http://www.in2p3.fr/symod">
    <xsl:output method="xml" indent="yes"/>

    <xsl:template match="symod:value[@join]">
        <value><xsl:apply-templates select="@*[local-name()!='join'] | * | text() | comment()"/>
            <parsedConstraint>
                <xsl:choose>
                    <xsl:when test="preceding::symod:value[@join=current()/@join]">
                        <declaration variable="{@join}"/>
                    </xsl:when>
                    <xsl:otherwise>
                        <comparison operator="equals">
                            <variable><xsl:value-of select="@join"/></variable>
                        </comparison>
                    </xsl:otherwise>
                </xsl:choose>
            </parsedConstraint>
        </value>
    </xsl:template>

    <!-- default templates -->
    <xsl:template match="*">
        <xsl:copy>
            <xsl:apply-templates select="@*|*|text()"/>
        </xsl:copy>
    </xsl:template>
    <xsl:template match="@* | text()">
        <xsl:copy-of select="."/>
    </xsl:template>
</xsl:stylesheet>
