<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:symod="http://www.in2p3.fr/symod" exclude-result-prefixes="symod"
                xmlns="http://www.in2p3.fr/symod">
    <xsl:output method="xml" indent="yes" xalan:indent-amount="4" xmlns:xalan="http://xml.apache.org/xslt"/>
    <xsl:strip-space elements="symod:*"/>

    <xsl:template match="symod:query">
        <query><xsl:copy-of select="@*"/>
            <xsl:apply-templates select="symod:description | symod:parsedTime"/>
            <xsl:apply-templates select="symod:query | symod:entity[1]"/>
            <xsl:copy-of select="symod:global_value"/>
        </query>
    </xsl:template>

    <xsl:template match="symod:entity">
        <entity><xsl:copy-of select="@*"/>
            <xsl:apply-templates select="symod:value[symod:* or @name or @null or @joinTime]"/>
            <xsl:apply-templates select="symod:entity_value"/>
        </entity>
    </xsl:template>

    <xsl:template match="symod:value/symod:parsedConstraint[symod:comparison[@operator='equals']/symod:variable]">
        <xsl:variable name="join" select="symod:comparison[@operator='equals']/symod:variable/text()"/>
        <xsl:apply-templates select="ancestor::symod:query/symod:entity[symod:value/symod:parsedConstraint/symod:declaration/@variable=$join]"/>
    </xsl:template>

    <xsl:template match="symod:value/symod:parsedConstraint[symod:declaration]">
        <xsl:attribute name="join">true</xsl:attribute>
    </xsl:template>

    <!-- workaround : attribute must be created before elements -->
    <xsl:template match="symod:value">
        <value><xsl:copy-of select="@*"/>
            <xsl:apply-templates select="symod:parsedConstraint"/>
            <xsl:apply-templates select="*[local-name()!='parsedConstraint'] | text()"/>
        </value>
    </xsl:template>

    <!-- default templates -->
    <xsl:template match="*">
        <xsl:copy>
            <xsl:apply-templates select="@*|*|text()"/>
        </xsl:copy>
    </xsl:template>
    <xsl:template match="@*|text()">
        <xsl:copy-of select="."/>
    </xsl:template>
</xsl:stylesheet>
