<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:ent="http://www.in2p3.fr/symod/schema"
                xmlns:cli="http://www.in2p3.fr/symod/cli" exclude-result-prefixes="ent cli"
                xmlns="http://www.in2p3.fr/symod">
    <xsl:output method="xml" omit-xml-declaration="yes"
                indent="yes" xalan:indent-amount="3" xmlns:xalan="http://xml.apache.org/xslt"/>
    <xsl:variable name="entities" select="document('entities.xml')/*"/>

    <xsl:template match="/cli:cli">
        <query>
            <time>
                <since duration="{@since}"/>
                <until duration="{@until}"/>
                <print as="Time"/>
            </time>
            <xsl:apply-templates select="cli:entities/cli:entity"/>
        </query>
    </xsl:template>

    <xsl:template match="cli:entity">
        <xsl:variable name="entity" select="@name"/>
        <entity TYPE="{@name}">
            <values>
                <xsl:apply-templates select="/cli:cli/cli:constraints/cli:constraint[@name = $entities/ent:entity[@id=$entity]/ent:*/ent:value/@id]"/>
            </values>
        </entity>
    </xsl:template>

    <xsl:template match="cli:constraint">
        <value TYPE="{@name}">
            <xsl:value-of select="cli:value"/>
        </value>
    </xsl:template>
</xsl:stylesheet>